#include <iostream>
#include <cstdio>
#include <map>
using namespace std;

int n,q,he[500005],ne[1000005],tn,t[1000005],d[500005],f[500005][30],lg[500005];

void qxx(int a,int b){
	tn++;
	ne[tn]=he[a];
	he[a]=tn;
	t[tn]=b;
	return ;
}

void js(int l,int fa){
	f[l][0]=fa;
	d[l]=d[fa]+1;
	for(int i=1;f[l][i-1]!=0;i++){
		f[l][i]=f[f[l][i-1]][i-1];
	}
	for(int i=he[l];i;i=ne[i]){
		if(t[i]!=fa){
			js(t[i],l);
		}
	}
	return ;
}

int lca(int a,int b){
	if(d[a]<d[b]) swap(a,b);
	for(int i=lg[n];i>=0;i--){
		if(d[f[a][i]]>=d[b]) a=f[a][i];
		if(a==b) return a;
	}
	for(int i=lg[n];i>=0;i--){
		if(f[a][i]!=f[b][i]){
			a=f[a][i];
			b=f[b][i];
		}
	}
	return f[a][0];
}

int main()
{
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin>>n;
	for(int i=1;i<n;i++){
		int a,b;
		cin>>a>>b;
		qxx(a,b);
		qxx(b,a);
		if(i>1) lg[i]=lg[i/2]+1;
	}
	lg[n]=lg[n/2]+1;
	js(1,0);
	cin>>q;
	while(q--){
		int l,r,k,pp=0,oo=0;
		cin>>l>>r>>k;
		for(int i=l;i+k-1<=r;i++){
			int j=i+k-1;oo=i;
			for(int x=i+1;x<=j;x++){
				oo=lca(oo,x);
			}
			pp=max(pp,d[oo]);
		}
		cout<<pp<<endl;
	}
//	fclose(stdin);fclose(stdout);
	return 0;
}
